import React, { useEffect, useCallback, useState, useMemo } from "react";
import logo from "./logo.svg";
import "./App.css";
import Converter from './helper/converter';

const Inputs = { toDecimal: "toDecimal", toRoman: "toRoman" };

function App() {
  // form
  const [toDecimalValue, setToDecimalValue] = useState("");
  const [toRomanValue, setToRomanValue] = useState("");

  const handleChange = useCallback(e => {
    e.preventDefault();
    const value = e.target.value.trim().toUpperCase();
    if (value) {
      if (e.target.name === Inputs.toDecimal) {
        setToDecimalValue(value);
      } else {
        setToRomanValue(value);
      }
    }
  }, []);

  useEffect(() => {
    console.log(toDecimalValue, toRomanValue);
  }, [toDecimalValue, toRomanValue]);

  // convert values
  const converted = useMemo(() => {
    const romanToBeConverted = toDecimalValue;
    const decimalToBeConverted = toRomanValue;
    return {
      toDecimal: Converter.fromRoman(romanToBeConverted),
      toRoman: Converter.toRoman(decimalToBeConverted)
    };
  }, [toDecimalValue, toRomanValue]);

  return (
    <div className="App">
      <header className="App-header">
        <img src={logo} className="App-logo" alt="logo" />

        <h2>Converter: Roman to Decimal</h2>
        <input name={Inputs.toDecimal} onChange={handleChange} />
        <span>Value is: {converted.toDecimal}</span>

        <h2>Converter: Decimal to Roman</h2>
        <input name={Inputs.toRoman} onChange={handleChange} />
        <span>Value is: {converted.toRoman}</span>
      </header>
    </div>
  );
}

export default App;
